/*-----------------------------------------------------------------------------
 PrintAdj.prg - On first app startup, adjust print position adjustment specs.
                Afterwards, adjustments made manually on control panel.

                The purpose of this is to automatically adjust the printer
                alignment insofar as possible so that users won't be
                disconcerted by misaligned printing when they are just
                getting familiar with an app (or during a phone demo).
 03/18/05
 Copyright (c) 2005 Leadership Software Corp.
*-----------------------------------------------------------------------------*/

#include "Fivewin.ch"

#define HORZSIZE            4
#define VERTSIZE            6
#define HORZRES             8
#define VERTRES            10
#define LOGPIXELSX         88
#define LOGPIXELSY         90

PROCEDURE PrintAdj(cIniName,lNewPrn)

LOCAL oDlg,oRadio,nSel,oGet,nGet := 00,cPrnLinCor := "",oGet2,;
      nPrnLinCor := 0, cPrnLinPol := "-",oSay20,cSay20 := "",nMultPoint := 0,;
      aFonts := {},oGet3,nBoxCor := .0,cBoxCor := "",lUpd:= .f.
LOCAL cIniFile := "", cIniFileW := "",cCurDir := ""
LOCAL hDC, nHorzRes, nHorzSize, nLogPixelX, nLogPixelY,;
      nVwork := 0,cPLCwork := "",cPrnUpd := "",lPrnUpd := .f.,cModel := ""
LOCAL nVertRes := 0,nVertSize := 0,aOffset := {},nYOffset := 0,nXOffset := 0,;
      nVtest := 0,nHtest := 0,nBoxwrk := 0,cBoxCorPol := "-",;
      nBoxWrkH:= 0,nBoxCorH := 0,cBoxCrPolH := "",cBoxCorH := "",;
      cOldPrinter := ""

DEFAULT lNewPrn := .f.
DEFAULT cIniName := "S360"

  cCurdir := CurDir()

  IF AT("\",cCurdir) > 0
     cCurdir := SUBSTR(cCurdir, AT("\",cCurdir)+1,10)
     cCurdir := Alltrim(cCurdir)
  ENDIF

*  cOldPrinter := PrnGetName()

  cIniFile := CurDrive()+":\"+CurDir()+"\"+cIniName+".ini"   
  cIniFileW := GetWinDir()+"\"+cIniName+".ini"

  IF !FILE(cIniFileW)
     cIniFileW := cIniFile
  ENDIF

 IF !lNewPrn
     cPrnUpd    :=     GetPvProfString( cIniName , "PrnUpd"  , "F" , cIniFileW )
     cPrnLinCor :=     GetPvProfString( cIniName , "PrnLinCor"  , "0" , cIniFileW )
     nMultPoint := VAL(GetPvProfString( cIniName , "MultPoint"  , "1" , cIniFileW ) )
     cModel     :=     GetPvProfString( cIniName , "PrinterSpecs", "", cIniFileW )
     nBoxCor    := VAL(GetPvProfString( cIniName , "BoxCor", "0", cIniFileW ) )
     cBoxCorPol :=     GetPvProfString( cIniName , "BoxCorPol", "-", cIniFileW )
     nBoxCorH   := VAL(GetPvProfString( cIniName , "BoxCorH", "0", cIniFileW ) )
     cBoxCrPolH :=     GetPvProfString( cIniName , "BoxCorPolH", "-", cIniFileW )
 ENDIF

  nPrnLinCor := VAL(cPrnLinCor)
  IF cPrnUpd == "T"
     lPrnUpd := .t.
  ELSE
     lPrnUpd := .f.
  ENDIF

  IF lPrnUpd .AND. !lNewPrn
     RETURN  // Automatic Printadj was done earlier. Now any changes must be
  ENDIF      // made manually on System Control Panel.

  IF !EMPTY(cModel)
     SetPrintDefault(cModel)
  ENDIF

  hDC  := GetPrintDefault( GetActiveWindow() )

  IF hDC = 0 // Handle rare case where computer has no printer.
     RETURN
  ENDIF

  IF EMPTY(cModel)
     cModel := PrnGetName()
  ENDIF


  // << See info at bottom of this file explaining GetDeviceCaps() >>

  nVertRes   := GetDeviceCaps( hDC, VERTRES  )   // in raster lines
  nHorzRes   := GetDeviceCaps( hDC, HORZRES  )   // in pixels

  nVertSize  := GetDeviceCaps( hDC, VERTSIZE )   // in millimeters
  nHorzSize  := GetDeviceCaps( hDC, HORZSIZE )   // in millimeters

  nLogPixelX := GetDeviceCaps( hDC, LOGPIXELSX ) // Printer's horiz pixels per logical inch
  nLogPixelY := GetDeviceCaps( hDC, LOGPIXELSY ) // Printer's vert pixels per logical inch

* IF nLogPixelX > 300 .AND. nMultPoint = 1
     nMultPoint := ROUND( nLogPixelX / 300 , 2 )
     lUpd := .t.
* ENDIF

  // Determine amount of Graphic Alignment adjustment needed, for nBoxCor...
  aOffset  := PrnOffset( hDC )
  nYOffset := aOffset[2]   // printer's vertical unprintable area
  nVtest   := 1
  nVtest   := Max( 0, ( nVtest * nVertRes / (nVertSize / 25.4 )) - nYOffset )
  nVtest   := nVtest / nMultPoint
  nXOffset := aOffset[1]   // printer's horizontal unprintable area
  nHtest   := 1
  nHtest   := Max( 0, ( nHtest * nHorzRes / (nHorzSize / 25.4 )) - nXOffset )
  nHtest   := nHtest / nMultPoint
*cc
*msginfo(str(nVtest)+"  "+str(nHtest),"nVtest  nHtest")

  nBoxWrk  := 270 - nVtest
  nBoxCor  := ROUND(nBoxWrk / nVtest, 2)
  nBoxCor  := nBoxCor + .06  // Workaround to line up right VERTICALLY.
  IF nBoxCor < 0
     cBoxCorPol := "-"
     nBoxCor := nBoxCor * -1
  ELSE
     cBoxCorPol := "+"
  ENDIF
  cBoxCor := STR(nBoxCor, 4, 2)
*cc
*msginfo(cBoxCor,"cBoxCor")

  nBoxWrkH  := 270 - nHtest
  nBoxCorH  := ROUND(nBoxWrkH / nHtest, 2)
  nBoxCorH  := nBoxCorH - .04  // Workaround to line up right HORIZONTALLY.
*cc
*msginfo(nBoxCorH,"nBoxCorH")
  IF nBoxCorH < 0
     cBoxCrPolH := "+"
     nBoxCorH := nBoxCorH * -1
  ELSE
     cBoxCrPolH := "-"
  ENDIF
  cBoxCorH := STR(nBoxCorH, 4, 2)

    // Get cPrnLinCor if .INI doesn't already have a value entered previously.
*  IF !lPrnUpd .AND. nPrnLinCor = 0
*cc
*msginfo(str(nVertRes)+"  "+str(nLogPixelY)+"  "+str(nHorzRes)+"  "+str(nLogPixelX),"nVertRes nLogPixelY nHorzRes nLogPixelX")

     nVwork := ROUND(nVertRes / 52.61, 0)
     nPrnLinCor := nVwork - 60
     IF nPrnLinCor > 0
        nPrnLinCor := 0
        cPrnLinCor := "0"
     ENDIF
     IF nPrnLinCor # 0
        cPLCwork := ALLTRIM(STR(nPrnLinCor))
        IF SUBSTR(cPLCwork,1,1) == "-" .OR. SUBSTR(cPLCwork,1,1) == "+"
           cPrnLinPol := SUBSTR(cPLCwork,1,1)
           cPrnLinCor := SUBSTR(cPLCwork,2,1)
           IF SUBSTR(cPLCwork,1,1) == "-"
              nSel := 1
            ELSE
              nSel := 2
           ENDIF
        ELSE
           cPrnLinCor := SUBSTR(cPLCwork,1,1)
        ENDIF
     ENDIF

     lUpd := .t.
*  ENDIF

/*
msginfo(STR(nVertRes)+" "+STR(nHorzRes)+" "+STR(nVertSize)+" "+STR(nHorzSize)+CRLF+;
        STR(nLogPixelX)+" "+STR(nLogPixelY),"nVR nHR nVS nHS nLPX nLPY")

msginfo(STR(nMultPoint)+" "+STR(nVwork)+" "+STR( nPrnLinCor),"nMultPoint nVwork nPrnLinCor")
*/

IF lUpd
     WritePProString( cIniName, "PrnLinCor"  , cPrnLinCor, cIniFileW )
     WritePProString( cIniName, "PrnLinPol"  , cPrnLinPol, cIniFileW )
     WritePProString( cIniName, "MultPoint"  , alltrim(str(nMultPoint,5,2)), cIniFileW )
     WritePProString( cIniName, "PrnUpd"  , "T", cIniFileW )
     WritePProString( cIniName, "PrinterSpecs"  , cModel, cIniFileW )
     WritePProString( cIniName, "BoxCor", cBoxCor, cIniFileW )
     WritePProString( cIniName, "BoxCorPol", cBoxCorPol, cIniFileW )
     WritePProString( cIniName, "BoxCorH", cBoxCorH, cIniFileW )
     WritePProString( cIniName, "BoxCorPolH", cBoxCrPolH, cIniFileW )
ENDIF

SetPLadj(nPrnLinCor)   // Set nPrnLinAdj in S360x() or Qcswin32().

  // cPrnLinPol tells polarity of adjustment -- plus or minus.
  // nPrnLinCor tells number of vertical units to add or subtract. [or lines???]
  // R&R uses 24 vertical units per line.

*  IF !EMPTY(cOldPrinter)
*     SetPrintDefault(cOldPrinter)
*  ENDIF

RETURN
*------------
/* NOTES:  ****************************************************
Syntax: (from FWH\MANUAL\Fwfun.chm)

 GetDeviceCaps( <hDC>, <nCapability> )  --> <nValue>  

 "Get Device Capabilities"

 This function retrieves the device-specific information about a given device.  

Parameters: 

 <hDC> The handle of the device context.  

 <nCapability> Specifies the type of information to be returned.  

Returns: 

 <nValue> The requested value.  

Defined codewords for nCapability query...

DT_PLOTTER       Vector plotter    
DT_RASDISPLAY    Raster display    
DT_RASPRINTER    Raster printer    
DT_RASCAMERA     Raster camera    
DT_CHARSTREAM    Character stream    
DT_METAFILE      Metafile    
DT_DISPFILE      Display file    
HORZSIZE         Width of the physical display, in millimeters.    
VERTSIZE         Height of the physical display, in millimeters.    
HORZRES          Width of the display, in pixels.    
VERTRES          Height of the display, in raster lines.    
LOGPIXELSX       Number of pixels per logical inch along the display width.    
LOGPIXELSY       Number of pixels per logical inch along the display height.    
BITSPIXEL        Number of adjacent color bits for each pixel.    
PLANES.          Number of color planes    
NUMBRUSHES       Number of device-specific brushes.    
NUMPENS          Number of device-specific pens.    
NUMMARKERS       Number of device-specific markers.    
NUMFONTS         Number of device-specific fonts.    
NUMCOLORS        Number of entries in the device's color table.    
ASPECTX          Relative width of a device pixel used for line drawing.    
ASPECTY          Relative height of a device pixel used for line drawing.    
ASPECTXY         Diagonal width of a device pixel used for line drawing.    
PDEVICESIZE      Size of the PDEVICE internal structure, in bytes.    
CLIPCAPS         Clipping capabilities the device supports. See FWH Fwfun.chm 
                   in \FWH\MANUAL for more info.

Comment from Bott on FWH webforum:

"I find that often print drivers are inaccurate. 
They don't report the proper values for width, height, and x and y offsets 
(non-printable areas). So first I would check these."

oPrn:nXOffset
oPrn:nYOffset
From... 
      aOffset    := PrnOffset( ::hDC )
      oPrn:nXOffset := aOffset[1]   // Width non-printable area
      oPrn:nYOffset := aOffset[2]   // Height non-printable area

"Also check [values via these methods]:"

oPrn:nVertSize()
oPrn:nHorzSize()
oPrn:nVertRes()
oPrn:nHorzRes() 
From...
   METHOD nVertSize() INLINE  GetDeviceCaps( ::hDC, VERTSIZE )
   METHOD nHorzSize() INLINE  GetDeviceCaps( ::hDC, HORZSIZE )
   METHOD nVertRes()  INLINE  GetDeviceCaps( ::hDC, VERTRES  )
   METHOD nHorzRes()  INLINE  GetDeviceCaps( ::hDC, HORZRES  )

From Bott's Testprn1.prg ...

//--- Set application's current printer. Returns .T. if successful.
// cPrinter must be the name of an existing print device.
function setPrinter(cPrinter)
   local cOldPrinter:="", hDC:=0, aPrn, cText:="", lSuccess:=.f.

   if cPrinter <> prnGetName()

      cText := StrTran(GetProfString("Devices"),Chr(0), chr(13)+chr(10))
      aPrn  := Array(Mlcount(cText, 250))
      Aeval(aPrn, {|v,e| aPrn[e] := Trim(Memoline(cText, 250, e)) } )

      if  ascan(aPrn,cPrinter) > 0

         cOldPrinter := GetProfString( "windows", "device" , "" )
         WriteProfString( "windows", "device", cPrinter )
         SysRefresh()
         PrinterInit()
         hDC := GetPrintDefault( GetActiveWindow() )
         if hDC>0
            lSuccess:= resetDC( hDC )
         endif
         SysRefresh()
         WriteProfString( "windows", "device", cOldPrinter  )

      endif

   endif
return lSuccess


*/