
#include "FiveWin.ch"

STATIC cCaller := "Q",cIniPrefx := "MyApp",cIniFile := "",cIniFileW := ""

 // Adjust length of printed page...
PROCEDURE PrnLen(nPrnLinAdj,oParent,cCall,lUseDlg,cParam)

LOCAL oDlg,oRadio,nSel,oGet,nGet := 00,cPrnLinCor := "",oGet2,;
      nPrnLinCor := 0, cPrnLinPol := "-",oSay20,cSay20 := "",nMultPoint := 0,;
      aFonts := {},oGet3,nBoxCor := .0,oRadio2,nSel2 := 1,cModel := "",cBoxCorPol := "-"
LOCAL cCurDir := "",oRept23,cOldPrinter := "",;
      lOk := .f.,hDC := 0

DEFAULT cCall := "Q"
DEFAULT lUseDlg := .t.
DEFAULT cParam := ""
IF EMPTY(cParam)
   cParam := ""
ENDIF

cCaller := cCall  // Code letter to identify which app is calling this proc

cIniPrefx := GetIniNam()

CLOSE DATABASES

   #ifdef __HARBOUR__
      SET RESOURCES TO "printp32.dll"
   #else
      SET RESOURCES TO "printpos.dll"
   #endif

   IF GetResources() < 32
       #ifndef __HARBOUR__
          MsgStop("Printpos.dll not found", "Error")
       #else
          MsgStop("Printp32.dll not found", "Error")
       #endif
       SetResources(hOldRes)
       RETU NIL
   ENDIF

   SetHelpFile("Printpos.hlp")


cCurdir := CurDir()
IF AT("\",cCurdir) > 0
     cCurdir := SUBSTR(cCurdir, AT("\",cCurdir)+1,10)
     cCurdir := Alltrim(cCurdir)
ENDIF

cIniFile := CurDrive()+":\"+CurDir()+"\"+cIniPrefx+".ini"   
cIniFileW := GetWinDir()+"\"+cIniPrefx+".ini"        // For use by net workstations


IF !FILE(cIniFileW)
   cIniFileW := cIniFile
ENDIF

cPrnLinCor :=     GetPvProfString( cIniPrefx , "PrnLinCor"  , "0" , cIniFileW )
cPrnLinPol :=     GetPvProfString( cIniPrefx , "PrnLinPol"  , "-" , cIniFileW )
nMultPoint := VAL(GetPvProfString( cIniPrefx , "MultPoint"  , "1" , cIniFileW ) )
nBoxCor    := VAL(GetPvProfString( cIniPrefx , "BoxCor"    , ".0" , cIniFileW ) )
cBoxCorPol :=     GetPvProfString( cIniPrefx , "BoxCorPol"  , "-" , cIniFileW )
cModel     :=     GetPvProfString( cIniPrefx , "PrinterSpecs", "" , cIniFileW )

*cc
*msginfo(cModel,"cModel")

// The next few lines automate protection from a GPF if printer not available...
hDC  := GetPrintDefault( GetActiveWindow() )
SysRefresh()

*cc
*msginfo(hDC,"hDC")

IF hDC = 0 // Handle rare case where computer has no printer.
   cParam := "X"   // (Previously, this param had to be manually entered when
ENDIF              // launching the app.)
*cc
*msginfo(cParam,"cParam")

IF EMPTY(cParam) .OR. cParam # "X"
                  // This will cause a crash if the workstation's default 
                  // network printer is unavailable...  !!!
   cOldPrinter := PrnGetName()
ELSE // cParam = "X"...
   MsgInfo("To correct a problem with default printer, on the "+CRLF+;
           "next dialog box, select the printer you want to use.","Fix printer selection...")
   PrinterSetup()
   SysRefresh()
   cOldPrinter := PrnGetName()
ENDIF


IF EMPTY(cModel)
   cModel := ""
ELSE
   SetPrintDefault(cModel)
   SysRefresh()
   PrinterInit()
   SysRefresh()
ENDIF

aFonts := {;
          {"TIMES NEW ROMAN", 0,-11, ""},;
          {"TIMES NEW ROMAN", 0,-11, "BOLD"},;
          {"TIMES NEW ROMAN", 0,-11, "ITALIC"},;
          {"", 0,0, ""},;
          {"", 0,0, ""},;
          {"", 0,0, ""};
          }

IF cBoxCorPol == "-"  // Note: screen symbols for plus & minus are the opposite 
                      //       from what is used here in actual calculations
   nSel2 := 1         //       in order to make it seem intuitive to the user.
ELSE
   nSel2 := 2
ENDIF

nPrnLinCor := VAL(cPrnLinCor)

cSay20 := ALLTRIM(cPrnLinPol) + ALLTRIM(cPrnLinCor)


IF lUseDlg

  DEFINE DIALOG oDlg RESOURCE "PRINTLEN" OF oParent ;
         TITLE "Printing Position Adjustments For: "+cModel
  
    // Current print length correction...
  REDEFINE SAY oSay20 PROMPT cSay20 ID 20 OF oDlg UPDATE
  
    // Remove (nSel=1) or Add (nSel=2) lines to printed page...
  REDEFINE RADIO oRadio VAR nSel ID 13,14 OF oDlg UPDATE
  
    // Number of lines to remove or add.
  REDEFINE GET oGet VAR nGet PICTURE "99" ID 101 OF oDlg UPDATE
         oGet:bGotFocus = {||oGet:SetPos(0,0)} 
  
  REDEFINE BUTTON ID 12 OF oDlg ;
    ACTION ( oRept23 := TRept23():New("PRINTEST.TXT",,aFonts,,.t.), ; // Print it
             oRept23:Activate(.t.), ;
             oRept23 := nil ;
            )
*  ACTION REPT23("PRINTEST.TXT",,aFonts)

    // Printhead point multiplier.
  REDEFINE GET oGet2 VAR nMultPoint PICTURE "9.99" ID 102 OF oDlg UPDATE
         oGet2:bGotFocus = {||oGet2:SetPos(0,0)} 
  
    // Graphics alignment correction.
  REDEFINE GET oGet3 VAR nBoxCor PICTURE "9.99" ID 103 OF oDlg UPDATE
         oGet3:bGotFocus = {||oGet3:SetPos(0,0)} 
  
    // "Plus" (nSel2=1) or "Minus" (nSel2=2) value on screen is opposite
    // of acutal plus and minus used for nBoxCor...
  REDEFINE RADIO oRadio2 VAR nSel2 ID 15,16 OF oDlg UPDATE ;
      ON CHANGE( IF(nSel2 = 1, cBoxCorPol := "-", cBoxCorPol := "+" ) )
  
  REDEFINE BUTTON ID 35 OF oDlg ;         // Change Printer
    ACTION ( PrinterSetup(),;
             PrinterSpecs(@nPrnLinAdj,@cPrnLinPol,@nPrnLinCor,;
                          @cPrnLinCor,@nMultPoint,@cModel,@nBoxCor,@nSel2),;
             IF(cPrnLinPol == "-",nSel := 1,nSel := 2),;
             cSay20 := ALLTRIM(cPrnLinPol) + ALLTRIM(cPrnLinCor),;
             oDlg:cTitle( "Printing Position Adjustments For: "+cModel ), ;
             oDlg:Update() ;
            )  
                // Had to add PrinterSpecs() to prevent "enhanced metafile 
                // error" that happens if any files are open before
                // TRept23 is called, using CLOSE DATABASES. Then added 
                // more functionality to it.

  REDEFINE BUTTON ID 11 OF oDlg ;
    ACTION PrnAdjust(@nPrnLinAdj,cCall,nSel,nGet,@cPrnLinPol,;
                  @nPrnLinCor,@cPrnLinCor,nMultPoint,nBoxCor,nSel2),;
                  cSay20 := ALLTRIM(cPrnLinPol) + ALLTRIM(STR(INT(nPrnLinAdj/24))),;
                  oSay20:Refresh(),;
           MsgInfo("Adjustments made as requested.")
  
  REDEFINE BUTTON ID 2 OF oDlg ;
    ACTION oDlg:End()
  
  REDEFINE BUTTON ID 4 OF oDlg ;
    ACTION HelpTopic( 1122 )
  
  ACTIVATE DIALOG oDlg CENTERED ;
        RESIZE16

ENDIF // lUseDlg

IF !EMPTY(cOldPrinter)
*cc
*  msginfo(cOldPrinter,"cOldPrinter")

   SetPrintDefault(cOldPrinter)
   SysRefresh()
   PrinterInit()
   SysRefresh()
ENDIF

  // cPrnLinPol tells polarity of adjustment -- plus or minus.
  // nPrnLinCor tells number of vertical units to add or subtract.
  // R&R uses 24 vertical units per line.

RETURN
*--------------
// Calculate new adjustment to printed page length (in # of printed lines) 
// based on prior total adjustment value plus or minus new additional 
// adjustment (nGet) from PrnLen()...
STATIC PROCEDURE PrnAdjust(nPrnLinAdj,cCall,nSel,nGet,cPrnLinPol,;
                        nPrnLinCor,cPrnLinCor,nMultPoint,nBoxCor,nSel2)

LOCAL cBoxCorPol := "-"
DEFAULT cCall := "Q"
cCaller := cCall

IF nSel = 1 .AND. cPrnLinPol == "-"
     nPrnLinCor := nPrnLinCor + nGet
    ELSEIF nSel = 1 .AND. cPrnLinPol == "+"
     nPrnLinCor := nPrnLinCor - nGet
    ELSEIF nSel = 2 .AND. cPrnLinPol == "-"
     nPrnLinCor := nPrnLinCor - nGet
    ELSEIF nSel = 2 .AND. cPrnLinPol == "+"
     nPrnLinCor := nPrnLinCor + nGet
    ELSE
     nPrnLinCor := nPrnLinCor + nGet
ENDIF

IF nPrnLinCor < 0 .AND. cPrnLinPol == "-"
     cPrnLinPol := "+"
     nPrnLinCor := -1 * nPrnLinCor  // Force to a positive number for ini.
   ELSEIF nPrnLinCor < 0 .AND. cPrnLinPol == "+"
     cPrnLinPol := "-"
     nPrnLinCor := -1 * nPrnLinCor  // Force to a positive number for ini.
    ELSE
ENDIF

IF nSel2 = 1
   cBoxCorPol := "-"
ELSE
   cBoxCorPol := "+"
ENDIF

WritePProString( cIniPrefx, "PrnLinCor"  , alltrim(str((nPrnLinCor),2)), cIniFileW )
WritePProString( cIniPrefx, "PrnLinPol"  , cPrnLinPol, cIniFileW )
WritePProString( cIniPrefx, "MultPoint"  , alltrim(str(nMultPoint,5,2)), cIniFileW )
WritePProString( cIniPrefx, "BoxCor"  , alltrim(str(nBoxCor,5,2)), cIniFileW )
WritePProString( cIniPrefx, "BoxCorPol"  , cBoxCorPol, cIniFileW )

nPrnLinAdj := nPrnLinCor * 24   // Passed back by reference to calling proc
IF cPrnLinPol == "+"           
   nPrnLinAdj := nPrnLinAdj * -1
ENDIF

SetPLadj(nPrnLinAdj)  // Reset nPrnLinAdj value in app's main prg.

RETURN
*---------------------
PROCEDURE PrinterSpecs(nPrnLinAdj,cPrnLinPol,nPrnLinCor,;
                       cPrnLinCor,nMultPoint,cModel,nBoxCor,nSel2)

LOCAL cInifile := "",cIniFileW := "",lNewPrn := .t.,cIniPrefx,cBoxCorPol := ""

DEFAULT nPrnLinAdj := 0
DEFAULT cPrnLinPol := ""
DEFAULT nPrnLinCor := 0
DEFAULT cPrnLinCor := ""
DEFAULT nMultPoint := 0
DEFAULT cModel := ""

cIniPrefx := GetIniNam()

cIniFile := CurDrive()+":\"+CurDir()+"\"+cIniPrefx+".ini"   
cIniFileW := GetWinDir()+"\"+cIniPrefx+".ini"


IF !FILE(cIniFileW)
   cIniFileW := cIniFile
ENDIF

cModel := PrnGetName()   //+"'"+PrnGetDrive()+","+PrnGetPort()

*cc
*msginfo(cModel+"  "+cIniFileW,"cModel  cIniFileW")

WritePProString( cIniPrefx, "PrinterSpecs"  , cModel, cIniFileW )
SysRefresh()
PrintAdj(cIniPrefx,lNewPrn)

cPrnLinCor :=     GetPvProfString( cIniPrefx , "PrnLinCor"  , "0" , cIniFileW )
cPrnLinPol :=     GetPvProfString( cIniPrefx , "PrnLinPol"  , "-" , cIniFileW )
nMultPoint := VAL(GetPvProfString( cIniPrefx , "MultPoint"  , "1" , cIniFileW ) )
nBoxCor    := VAL(GetPvProfString( cIniPrefx , "BoxCor", "0", cIniFileW ) )
cBoxCorPol :=     GetPvProfString( cIniPrefx , "BoxCorPol", "-", cIniFileW )

nPrnLinCor := VAL(cPrnLinCor)

nPrnLinAdj := nPrnLinCor * 24
IF cPrnLinPol == "+"           
   nPrnLinAdj := nPrnLinAdj * -1
ENDIF

IF cBoxCorPol == "-"
   nSel2 := 1
ELSE
   nSel2 := 2
ENDIF

CLOSE DATABASES

RETURN
*---------------------------

