#include "FiveWin.ch"   // FWH 2.7 Report.prg with prior RWS mods added
#include "objects.ch"
#include "report.ch"

#define RPT_CONTIN       6   // Added by RWS 6/12/00

#define GRID_ABOVE       0
#define GRID_BELOW       1
#define GRID_ABOBEL      2

#define PORTRAIT         1
#define LANDSCAPE        2

#define TXT_CANCEL ;
        LoadString( GetResources(), 1 )
#define TXT_PRINTING_PAGE ;
        LoadString( GetResources(), 2 )
#define TXT_PREVIEW ;
        LoadString( GetResources(), 3 )
#define TXT_BUILDING_PAGE ;
        LoadString( GetResources(), 4 )
#define TXT_REPORT_WIDTH ;
        LoadString( GetResources(), 5 )
#define TXT_ATENTION ;
        LoadString( GetResources(), 6 )

#ifdef __XPP__
   #define New  _New
#endif

//----------------------------------------------------------------------------//

CLASS TReport

   DATA oDevice, oTitle, oHeader, oFooter, oRptWnd, oShdBrush, oPenHorz
   DATA aGroups, aColumns, aFont, aCols, aText, aData, aPen, ;
        aDataHeight, aClrText
   DATA bFor, bWhile , bInit, bEnd, bStartLine, bEndLine, bStartPage, ;
        bEndPage, bStartGroup, bEndGroup, bSkip, bStdFont, bPreview, ;
        bChange, bPostEnd, bPostPage, bPostGroup, bStartRecord
   DATA cRptFile, cResName, cFile, cName, cPageTotal, cGrandTotal,;
        cCharPattern
   DATA nWidth, nHeight, nMargin, nRow, nPage, nMaxTitle, nMaxData,;
        nSeparator, nLeftMargin, nRightMargin, nTopMargin, nDnMargin,;
        nTitleRow, nBottomRow, nStdLineHeight, nRptWidth, nLogPixX,;
        nLogPixY, nFirstdrow, nLastdrow, nTitleHeight, nCounter,;
        nTotalLine, nGroupLine, nTitleUpLine, nTitleDnLine, nClrShadow,;
        nDataLine
   DATA hOldRes
   DATA lSummary, lTotal, lFinish, lStable, lGroup, lPrinter, lScreen,;
        lFirstRow, lCreated, lBreak, lShadow, lGrid, lJoin, lSeparator,;
        lAutoLand, lIsNarrow, lBoxOnTotal, lNoCancel, lPageTotal,;
        lDblSpace,;  // added by RWS 3/5/02
        lEndPgDone,; // added by RWS 10/29/06 to condition ::EndLine()
        lRept23      // Added by RWS 10/30/06 to condition ::NeedNewLine()
   DATA Cargo

   METHOD New( aTitle, aHead, aFoot, aFont, lSummary, cRptFile, ;
               cResName, lPrinter, lScreen, cFile, oDevice, ;
               cName, cTFmt, cHFmt, cFFmt ) CONSTRUCTOR

   //METHOD FromFile() CONSTRUCTOR    Not available yet!
   //METHOD Resource() CONSTRUCTOR    Not available yet!

   METHOD AddColumn(oColumn) INLINE Aadd(::aColumns,oColumn)

   METHOD DelColumn(nColumn) INLINE Adel(::aColumns,nColumn) ,;
                                    Asize(::aColumns,len(::aColumns)-1)

   METHOD InsColumn(oColumn ,;
                     nColumn) INLINE Ains(::aColumns,nColumn) ,;
                                     ::aColumns[nColumn]:= oColumn

   METHOD AddGroup(oGroup)   INLINE Aadd(::aGroups,oGroup)

   METHOD DelGroup(nGroup)   INLINE Adel(::aGroups,nGroup)   ,;
                                    Asize(::aGroups,len(::aGroups)-1)

   METHOD Stabilize()
   METHOD Skip(n)

   METHOD Init()
   METHOD End()

   METHOD StartLine(nHeight)
   METHOD EndLine(nHeight)
   METHOD StartGroup(nGroup)
   METHOD EndGroup(nGroup)
   METHOD StartPage()
   METHOD EndPage()

*  METHOD NeedNewPage() INLINE ( ::nRow+ ::nStdLineHeight >= ::nBottomRow)
   METHOD NeedNewPage()  // Converted to regular method by RWS 10/30/06

   METHOD NewLine(nHeight) INLINE (::StartLine(nHeight) ,;
                                   iif(!::lFirstRow, ::EndLine(nHeight),))

   METHOD BackLine(nLine) INLINE  ::nRow -= ::nStdLineHeight* ;
                                  iif(nLine == NIl,1 ,nLine )


   METHOD ColTitle()
   METHOD TotalLine(cChar, nGrid)
   METHOD PageTotal()

   METHOD Activate(bFor, bWhile, bInit, bEnd, bStartPage, ;
                   bEndPage, bStartGroup, bEndGroup, ;
                   bStartLine, bEndLine, bChange, ;
                   bPostEnd, bPostPage, bPostGroup  )

   METHOD Play()

   METHOD Margin(nValue,nType,nScale)

   METHOD Say(nCol, xText, nFont, nPad, nRow, nStart)

   METHOD SayBitmap(nRow, nCol, cBitmap, nWidth, nHeight, nScale)
   METHOD Box(nRow, nCol, nBottom, nRight, nPen, nScale )
   METHOD Line( nTop, nLeft, nBottom, nRight, nPen, nScale )
   METHOD Shadow(nHeight)
   METHOD Grid(nHeight, nRow, cChar)
   METHOD Separator(nPen, nRow)

   METHOD CellView() INLINE ::lJoin       := .T. ,;
                            ::lSeparator  := .T. ,;
                            ::lBoxOnTotal := .T. ,;
                            Aeval(::aColumns,{|val| val:lGrid := .T.})

   METHOD PhyWidth(nScale) INLINE ;
                  ( iif(nScale==NIL,nScale:=1 ,),;
                    PrnGetSize(::oDevice:hDC)[1] / ::nLogPixX * ;
                    iif(nScale==1 ,1 ,2.54)                     )

   METHOD PhyHeight(nScale) INLINE ;
                  ( iif(nScale==NIL,nScale:=1 ,),;
                    PrnGetSize(::oDevice:hDC)[2] / ::nLogPixY * ;
                    iif(nScale==1 ,1 ,2.54)                     )

   METHOD SetTxtColor(nColor,nFont) INLINE                          ;
                  (iif(nColor != NIL .AND.                          ;
                       nFont   > 0   .AND.                          ;
                       nFont   <= len(::aClrText)                  ,;
                       ::aClrText[nFont] := nColor, ) )

   METHOD SetShdColor(nColor) INLINE ::nClrShadow := nColor

   METHOD SetPenColor(nColor)

ENDCLASS

//----------------------------------------------------------------------------//

METHOD New( aTitle, aHead, aFoot, aFont, aPen, lSummary, cRptFile, ;
            cResName, lPrinter, lScreen, cFile, oDevice, cName,;
            cTFmt, cHFmt, cFFmt) CLASS TReport

   LOCAL nFor, nTFmt, nHFmt, nFFmt

   LOCAL lFontDefined := .T. ,;
         lPenDefined  := .T.

   #ifdef __XPP__
      #undef New
   #endif

   DEFAULT aTitle      := {{|| ""} }         ,;
           aHead       := {{|| ""} }         ,;
           aFoot       := {{|| ""} }         ,;
           aFont       := {}                 ,;
           aPen        := {}                 ,;
           lSummary    := .F.                ,;
           cRptFile    := ""                 ,;
           cResName    := ""                 ,;
           lPrinter    := .F.                ,;
           lScreen     := .F.                ,;
           cFile       := ""                 ,;
           cTFmt       := "CENTER"           ,;
           cHFmt       := "LEFT"             ,;
           cFFmt       := "LEFT"

   CursorWait() // 8/14/03

   ::aColumns     := {}
   ::aGroups      := {}
   ::bStdFont     := {|| 1 }
   ::bPreview     := {|oDevice| RPreview(oDevice) }
   ::cRptFile     := cRptFile
   ::cResName     := cResName
   ::cPageTotal   := ""
   ::cGrandTotal  := ""
   ::cCharPattern := CHAR_PATTERN  // "B" in Report.ch
   ::cFile        := cFile
   ::cName        := cName
   ::nRow         := 0
   ::nPage        := 0
   ::nSeparator   := 0
   ::nCounter     := 0
   ::nTotalLine   := RPT_DOUBLELINE
   ::nGroupLine   := RPT_SINGLELINE
   ::nTitleUpLine := RPT_DOUBLELINE
   ::nTitleDnLine := RPT_DOUBLELINE
   ::nClrShadow   := CLR_LIGHTGRAY
   ::lSummary     := lSummary
   ::lStable      := .F.
   ::lPrinter     := lPrinter
   ::lScreen      := lScreen
   ::lFirstRow    := .T.
   ::lCreated     := .F.
   ::lBreak       := .F.
   ::lShadow      := .F.
   ::lJoin        := .F.
   ::lSeparator   := .F.
   ::lAutoLand    := .f.  //.T. RWS changed to .f. so "too wide" text won't trigger landscape
   ::lIsNarrow    := .F.
   ::lBoxOnTotal  := .F.
   ::lNoCancel    := .F.
   ::lPageTotal   := .T.
   ::lDblSpace    := .f.  // RWS added 3/5/02
   ::lEndPgDone   := .f.  // RWS added 10/29/06 to condition ::EndLine()
   ::lRept23      := .f.  // RWS added 10/30/06 to condition ::NeedNewLine()

   IF cTFmt == "LEFT"
      nTFmt = RPT_LEFT
   ELSEIF cTFmt == "RIGHT"
      nTFmt = RPT_RIGHT
   ELSEIF cTFmt == "CENTER" .OR. cTFmt == "CENTERED"
      nTFmt = RPT_CENTER
   ELSE
      nTFmt = RPT_CENTER
   ENDIF

   IF cHFmt == "LEFT"
      nHFmt = RPT_LEFT
   ELSEIF cHFmt == "RIGHT"
      nHFmt = RPT_RIGHT
   ELSEIF cHFmt == "CENTER" .OR. cHFmt == "CENTERED"
      nHFmt = RPT_CENTER
   ELSE
      nHFmt = RPT_LEFT
   ENDIF

   IF cFFmt == "LEFT"
      nFFmt = RPT_LEFT
   ELSEIF cFFmt == "RIGHT"
      nFFmt = RPT_RIGHT
   ELSEIF cFFmt == "CENTER" .OR. cFFmt == "CENTERED"
      nFFmt = RPT_CENTER
   ELSE
      nFFmt = RPT_LEFT
   ENDIF

   /*
   Indicar device
   Indicate device
   */

   CursorWait() // 8/14/03

   IF oDevice <> NIL
      ::oDevice  := oDevice
      ::lScreen  := oDevice:lMeta
      ::lPrinter := !::lScreen
   ELSEIF ::lPrinter
      ::oDevice  := TPrinter():New(cName,.F.)
   ELSEIF ::lScreen
      CursorWait() // 8/14/03
      // Can add a 5th param as .T. ( lModal ) so preview screen 
      // will be on top --  TPrinter():New(cName,.F.,.T.,cModel,.T.)
*      ::oDevice := TPrinter():New(cName,.F.,.T.)
      ::oDevice := TPrinter():New(cName, .T., .T.,, .T.) 
      CursorWait() // 8/14/03
   ELSEIF !empty(::cFile)
      ::oDevice  := TRFile():New(::cFile)
      ::lPrinter := .F.
   ELSE
      ::oDevice  := TPrinter():New(cName,.F.)
      ::lPrinter := .T.
   ENDIF

   CursorWait() // 8/14/03

   /*
   Nombre del listado
   Name of report
   */

   IF empty(::cName)
     IF !empty(::oDevice:cDocument)
          ::cName := ::oDevice:cDocument
     ELSE
          ::cName := "Printing report"
     ENDIF
   ENDIF

   /*
   Control de que el device es correcto
   Determine if control by the device is correct
   */

   IF empty(::oDevice:hDC)
      RETURN Self              // changed from nil to self 11/15/06 RWS
   ELSE
      ::lCreated := .T.
   ENDIF

   /*
   Pedir coordenadas del device
   Ask for the coordinates of the device
   */

   ::nWidth  := ::oDevice:nHorzRes()
   ::nHeight := ::oDevice:nVertRes()

   /*
   Calcular n de pixels por pulgada del device
   Calculation of pixels per inch of the device
   */

   ::nLogPixX := ::oDevice:nLogPixelX()
   ::nLogPixY := ::oDevice:nLogPixelY()

   /*
   Si no ha especificado font asignar ARIAL 10
   If no font specified, assign ARIAL 10
   */

   IF len(aFont) == 0
      lFontDefined := .F.
      Asize(aFont,1)
      DEFINE FONT aFont[1] NAME "ARIAL" SIZE 0,-10
   ENDIF

   /*
   Si no se ha especificado pen crearlo (por si acaso)
   If no pen specified, create it (just in case)
   */

   IF len(aPen) == 0
      lPenDefined := .F.
      Asize(aPen,1)
      DEFINE PEN aPen[1] STYLE 0 WIDTH 1 COLOR CLR_BLACK
   ENDIF

   /*
   Crear pen para las lineas horizontales igual que el primero definido
   Create pen for horizontal lines equal to the default definition
   */

   DEFINE PEN ::oPenHorz   ;
      STYLE aPen[1]:nStyle ;
      WIDTH aPen[1]:nWidth * ::nLogPixX/72 ;
      COLOR aPen[1]:nColor

   /*
   Crear nuevos fonts basandonos en el Device para ajustar
   el tamao de los mismos al device elegido
   Create new fonts based on the Device, adjusting the size
   the same as the selected device
   */

   ::aFont := Array(len(aFont))

   Aeval(aFont                                        ,;
         {|val,elem|                                   ;
         ::aFont[elem]:= TFont():New(val:cFaceName    ,;
         Int(val:nWidth*::nLogPixX/72)                ,;
         Int(val:nHeight*::nLogPixY/72)               ,;
         .F.                                          ,;
         val:lBold                                    ,;
         val:nEscapement                              ,;
         val:nOrientation                             ,;
         val:nWeight                                  ,;
         val:lItalic                                  ,;
         val:lUnderline                               ,;
         val:lStrikeOut                               ,;
         val:nCharSet                                 ,;
         val:nOutPrecision                            ,;
         val:nClipPrecision                           ,;
         val:nQuality) })

   IF !lFontDefined
      aFont[1]:end()
   ENDIF

   /*
   Crear nuevos Pens basandonos en el device
   Create new Pens based on the device
   */

   ::aPen := Array(len(aPen))

   Aeval(aPen, {|val,elem|                             ;
               ::aPen[elem] := Tpen():New( val:nStyle ,;
               Int(val:nWidth*::nLogPixX/72)          ,;
               val:nColor)} )

   IF !lPenDefined
      aPen[1]:end()
   ENDIF

   /*
   Crear Matriz de colores para impresin de texto
   Create Matrix of colors for the printing of text
   */

   ::aClrText := Array(len(::aFont))

   Aeval(::aClrText,{|val,elem| ::aClrText[elem] := CLR_BLACK })

   /*
   Establecer margenes de impresin a 0,2 pulgadas
   Establish default margins for printing at 0.2 inches all around
   */

   ::nLeftMargin  := Int(::nLogPixX*0.2)
   ::nRightMargin := Int(::nLogPixX*0.2)
   ::nTopMargin   := Int(::nLogPixY*0.2)
   ::nDnMargin    := Int(::nLogPixY*0.2)

   /*
   Crear objetos del listado
   Create objects for the report
   */

   ::oHeader := TrLine():New(aHead,Self,nHFmt)
   ::oTitle  := TrLine():New(aTitle,Self,nTFmt)
   ::oFooter := TrLine():New(aFoot,Self,nFFmt)

   CursorWait() // 8/14/03

RETURN Self   // Must return Self here cause 32 bits version

//----------------------------------------------------------------------------//

METHOD Margin(nValue, nType, nScale) CLASS TReport


   DEFAULT nValue := .2         ,;
           nType  := RPT_LEFT   ,;
           nScale := RPT_INCHES

   IF nScale == RPT_CMETERS
      nValue := Int(nValue/2.54)
   ENDIF

   DO CASE
   CASE nType == RPT_TOP
      ::nTopMargin   := Int(::nLogPixY*nValue)
   CASE nType == RPT_BOTTOM
      ::nDnMargin    := Int(::nLogPixY*nValue)
   CASE nType == RPT_LEFT
      ::nLeftMargin  := Int(::nLogPixX*nValue)
   CASE nType == RPT_RIGHT
      ::nRightMargin := Int(::nLogPixX*nValue)
   ENDCASE

   ::lStable := .F.

RETURN NIL

//----------------------------------------------------------------------------//

METHOD Say( nCol, xText, nFont, nPad, nRow, nStart ) CLASS TReport
                                        // nStart added by RWS 6/12/00
                                        // It comes from REPT23.PRG only.
   LOCAL nStartCol, cText, nNext := 0   // cText and nNext added by RWS
   STATIC nLastPos                 // added by RWS 6/12/00

   DEFAULT nCol  := 1        ,;
           nFont := 1        ,;
           xText := ""       ,;
           nRow  := ::nRow   ,;
           nPad  := RPT_LEFT ,;  // = 1
           nStart := 0      

   CursorWait()    // RWS 8/14/03

   nStartCol := 0  // RWS

   IF nPad # 6 .AND. nPad # 7   // This code section added back by RWS
      nLastPos := 0
   ELSEIF nPad = 7        // Moving print head to a tab
      nLastPos := nStart
      nPad := 6
   ENDIF

   IF nCol < 1 .OR. nCol > Len( ::aCols )
      nCol := 1
   ENDIF

   IF nFont < 1 .OR. nFont > Len( ::aFont )
      nFont := 1
   ENDIF

   cText := cValToChar(xText)

   DO CASE

   CASE nPad == RPT_LEFT    // = 1
      nStartCol := ::aCols[nCol]
      IF(!EMPTY(nStart), nStartCol := nStart,)
                                               // Both RIGHT and CENTER have
   CASE nPad == RPT_RIGHT   // = 2             // less code lines after FW 2.0
      nStartCol := ::aCols[nCol]+;
                   ::aColumns[nCol]:nWidth    

      SetTextAlign(::oDevice:hDCOut,2)
   CASE nPad == RPT_CENTER  // = 3    top = 4; bottom = 5
      nStartCol := ::aCols[nCol]+;
                   Int(::aColumns[nCol]:nWidth/2)

      SetTextAlign(::oDevice:hDCOut,6)

   CASE nPad == RPT_CONTIN  // =6 line continuation, added by RWS 6/12/00
      nStartCol := nLastPos     // and 7 is "set printhead position at"

   OTHERWISE
      nStartCol := ::aCols[nCol]
      IF(!EMPTY(nStart), nStartCol := nStart,)
   ENDCASE

   ::oDevice:Say(nRow             ,;   // This Say() is in Printer.prg
                 nStartCol        ,;
                 cText            ,;
                 ::aFont[nFont]   ,;
                 NIL              ,;
                 ::aClrText[nFont],;
                 nPad-1)               // in FWH 2.7

   nNext := Int(::oDevice:GetTextWidth(cText,::aFont[nFont]))


   IF(EMPTY(nStartCol), nStartCol := 0,)
   IF(EMPTY(nNext), nNext := 0,)

   nLastPos := nStartCol + nNext 

   CursorWait() // 8/14/03

RETURN NIL

//----------------------------------------------------------------------------//

METHOD SayBitmap(nRow, nCol, cBitmap, nWidth, nHeight, nScale) CLASS TReport

   LOCAL nPixWidth, nPixHeight
   LOCAL aOffset

   DEFAULT nRow    := .2       ,;
           nCol    := .2       ,;
           nWidth  := 1        ,;
           nHeight := 1        ,;
           nScale  := RPT_INCHES

   IF nScale == RPT_CMETERS
      aOffset := ::oDevice:Cmtr2Pix(nRow, nCol)
      nWidth  := nWidth/2.54
      nHeight := nHeight/2.54
   ELSE
      aOffset := ::oDevice:Inch2Pix(nRow, nCol)
   ENDIF

   nPixWidth  := ::nLogPixY*nWidth
   nPixHeight := ::nLogPixX*nHeight

   ::oDevice:SayBitmap(aOffset[1] ,;
                       aOffset[2] ,;
                       cBitmap    ,;
                       nPixWidth  ,;
                       nPixHeight)

RETURN NIL

//----------------------------------------------------------------------------//

METHOD Box(nRow, nCol, nBottom, nRight, nPen, nScale ) CLASS TReport

   LOCAL aStart, aEnd

   DEFAULT nRow    := .2   ,;
           nCol    := .2   ,;
           nBottom := 5    ,;
           nRight  := 5    ,;
           nPen    := 1    ,;
           nScale  := RPT_INCHES

   IF nScale == RPT_CMETERS
      aStart := ::oDevice:Cmtr2Pix(nRow, nCol)
      aEnd   := ::oDevice:Cmtr2Pix(nBottom, nRight)
   ELSE
      aStart := ::oDevice:Inch2Pix(nRow, nCol)
      aEnd   := ::oDevice:Inch2Pix(nBottom, nRight)
   ENDIF

   ::oDevice:Box(aStart[1]    ,;
                 aStart[2]    ,;
                 aEnd[1]      ,;
                 aEnd[2]      ,;
                 ::aPen[nPen])

RETURN NIL

//----------------------------------------------------------------------------//

METHOD Line( nRow, nCol, nBottom, nRight, nPen, nScale ) CLASS TReport

   LOCAL aStart, aEnd

   DEFAULT nRow    := .2   ,;
           nCol    := .2   ,;
           nBottom := 5    ,;
           nRight  := 5    ,;
           nPen    := 1    ,;
           nScale  := RPT_INCHES

*cc
*msginfo(::oDevice:nXOffset,"nXOffset")
*msginfo(::oDevice:nYOffset,"nYOffset")
*msginfo(::oDevice:nVertSize(),"nVertSize")
*msginfo(::oDevice:nHorzSize(),"nHorzSize")
*msginfo(::oDevice:nVertRes(),"nVertRes")
*msginfo(::oDevice:nHorzRes(),"nHorzRes") 
*nRow := 1
*nBottom := 1
   IF nScale == RPT_CMETERS
      aStart := ::oDevice:Cmtr2Pix(nRow, nCol)
      aEnd   := ::oDevice:Cmtr2Pix(nBottom, nRight)
   ELSE
      aStart := ::oDevice:Inch2Pix(nRow, nCol)
      aEnd   := ::oDevice:Inch2Pix(nBottom, nRight)
   ENDIF
*cc
*msginfo(STR(nRow)+"  "+STR(nCol),"nRow nCol - A")
*msginfo(STR(aStart[1])+"  "+STR(aStart[2]),"nRow nCol - B")
*aStart[1] := 1250 ; aEnd[1] := 1250

   ::oDevice:Line(aStart[1]    ,;
                  aStart[2]    ,;
                  aEnd[1]      ,;
                  aEnd[2]      ,;
                  ::aPen[nPen])

RETURN NIL

//----------------------------------------------------------------------------//

METHOD Shadow (nHeight) CLASS TReport

   LOCAL nFor, nCols, nGrid

   IF !::lShadow
     RETU NIL
   ENDIF

   nCols := len(::aColumns)

   IF ::oShdBrush == NIL
       DEFINE BRUSH ::oShdBrush COLOR ::nClrShadow
   ENDIF

   FOR nFor := 1 TO nCols
      IF ::aColumns[nFor]:lShadow

         IF ::aColumns[nFor]:lGrid
            nGrid := ::aPen[::aColumns[nFor]:nPen]:nWidth * 2
         ELSE
            nGrid := 0
         ENDIF

         SetbkMode( ::oDevice:hDCOut, 1 )

         ::oDevice:FillRect({::nRow         ,;
                             ::aCols[nFor] -nGrid  ,;
                             ::nRow+nHeight  ,;
                             ::aCols[nFor]+::aColumns[nFor]:nWidth+nGrid} ,;
                              ::oShdBrush)
      ENDIF
      CursorWait()  // RWS 02/11/03
   NEXT

RETURN NIL

//----------------------------------------------------------------------------//

METHOD Grid (nHeight, nRow, cChar) CLASS TReport

   LOCAL nFor, nCols

   DEFAULT nHeight    := ::nStdLineHeight ,;
           nRow       := ::nRow

   IF !::lGrid .OR. empty(nHeight)
     RETU NIL
   ENDIF

   nCols := len(::aColumns)

   IF ::lScreen .OR. ::lPrinter

        FOR nFor := 1 TO nCols

           IF ::aColumns[nFor]:lGrid

              SetbkMode( ::oDevice:hDCOut, 1 )

              ::oDevice:line(nRow    ,;
                             ::aCols[nFor]-(::nSeparator/2)   ,;
                             nRow+nHeight     ,;
                             ::aCols[nFor]-(::nSeparator/2),;
                             ::aPen[::aColumns[nFor]:nPen])
              ::oDevice:line(nRow    ,;
                             ::aCols[nFor]+::aColumns[nFor]:nWidth+(::nSeparator/2) ,;
                             nRow+nHeight     ,;
                             ::aCols[nFor]+::aColumns[nFor]:nWidth+(::nSeparator/2) ,;
                             ::aPen[::aColumns[nFor]:nPen])
           ENDIF

           CursorWait()  // RWS 02/11/03
        NEXT

     ELSE

        IF cChar == NIL
           cChar := ""
        ENDIF

        FOR nFor := 1 TO nCols

           IF ::aColumns[nFor]:lGrid

              ::oDevice:Say(nRow    ,;
                            ::aCols[nFor]-::nSeparator ,;
                            Replicate(cChar,::nSeparator) ,;
                            ::aFont[eval(::bStdFont)],;
                            ::nSeparator)

              ::oDevice:Say(nRow    ,;
                            ::aCols[nFor]+::aColumns[nFor]:nWidth ,;
                            Replicate(cChar,::nSeparator) ,;
                            ::aFont[eval(::bStdFont)],;
                            ::nSeparator)

           ENDIF

           CursorWait()  // RWS 02/11/03
        NEXT

     ENDIF

RETURN NIL

//----------------------------------------------------------------------------//

METHOD Separator (nPen, nRow) CLASS TReport

     LOCAL oPen
     LOCAL cSeparator
     LOCAL nLeft, nRight

     DEFAULT nRow := ::nRow ,;
             nPen := 1

     nLeft  := ::nMargin
     nRight := nLeft

     Aeval(::aColumns, {|v| nRight += v:nWidth } )

     nRight += ((len(::aColumns)-1)*::nSeparator)

     IF !::lPrinter .AND. !::lScreen

          cSeparator := ""
          Aeval(::aColumns,;
                {|val| cSeparator += Replicate("",val:nWidth)+"" })
          cSeparator := ""+Substr(cSeparator,1,len(cSeparator)-1)+""
          ::oDevice:Say(nRow, nLeft-::nSeparator, cSeparator)
          ::Shadow(::nStdLineHeight)
          ::nRow += ::nStdLineHeight
          RETU NIL

     ENDIF

     IF ::aColumns[1]:lGrid
          nLeft -= Int(::nSeparator/2)
     ENDIF

     IF Atail(::aColumns):lGrid
          nRight += Int(::nSeparator/2)
     ENDIF

     IF nPen != NIL .AND. nPen > 0 .AND. nPen < len(::aPen)
          oPen := ::aPen[nPen]
     ELSE
          oPen := ::oPenHorz
     ENDIF

     //::oDevice:Line(nRow, nLeft, nRow, nRight, oPen)
     Aeval(::aColumns, {|v| v:Separator(nRow)})
     ::NewLine(oPen:nWidth*4)

RETURN NIL

//----------------------------------------------------------------------------//

METHOD SetPenColor(nColor) CLASS TReport

   IF nColor == NIL
       RETU NIL
   ENDIF

   ::oPenHorz:End()

   DEFINE PEN ::oPenHorz ;
      STYLE 0 ;
      WIDTH Int(1*::nLogPixX/72) ;
      COLOR nColor

RETURN NIL

//----------------------------------------------------------------------------//

METHOD Activate(bFor, bWhile, bInit, bEnd, bStartPage, ;
                bEndPage, bStartGroup, bEndGroup, ;
                bStartLine, bEndLine, bChange, ;
                bPostEnd, bPostPage, bPostGroup ;
                ) CLASS TReport


   LOCAL oPagina
   LOCAL hActWnd := GetActiveWindow()

   DEFAULT bFor     := {|| .T.    } ,;
           bWhile   := {|| !eof() }

   SysRefresh()                   // Added by RWS 11/04/06

   ::hOldRes := GetResources()

   SysRefresh()                   // Added by RWS 11/04/06

   #ifdef __CLIPPER__
      SET RESOURCES TO "preview.dll"
   #else
      SET RESOURCES TO "prev32.dll"
   #endif

   SysRefresh()                   // Added by RWS 11/04/06

   IF GetResources() < 32
       #ifdef __CLIPPER__
          MsgStop( "Preview.dll not found", "Error" )
       #else
          MsgStop( "Prev32.dll not found", "Error" )
       #endif
       SetResources(::hOldRes)
       RETU NIL
   ENDIF

   DEFAULT ::bFor        := bFor        ,;
           ::bWhile      := bWhile      ,;
           ::bInit       := bInit       ,;
           ::bEnd        := bEnd        ,;
           ::bStartPage  := bStartPage  ,;
           ::bEndPage    := bEndPage    ,;
           ::bStartGroup := bStartGroup ,;
           ::bEndGroup   := bEndGroup   ,;
           ::bStartLine  := bStartLine  ,;
           ::bEndLine    := bEndLine    ,;
           ::bChange     := bChange     ,;
           ::bPostEnd    := bPostEnd    ,;
           ::bPostPage   := bPostPage   ,;
           ::bPostGroup  := bPostGroup

   /*
   Si hay una condicin For y ademas grupos entonces
   nos posicionamos en el primer registro valido
   If there is a condition FOR in addition to groups, then
   position us in the first valid record
   */

   IF len(::aGroups) > 0
      DO WHILE eval(::bWhile) .AND. !eval(::bFor)
         SysRefresh()
         ::Skip(1)
      ENDDO
   ENDIF

   /*
   Estabilizar el listado
   Stabilize the report
   */

   IF !::lCreated
       ::End()
       RETU NIL
   ENDIF

   ::Stabilize()

   IF ::lIsNarrow
        ::oDevice:SetLandScape()
        ::nWidth  := ::oDevice:nHorzRes()
        ::nHeight := ::oDevice:nVertRes()
        ::Stabilize()
   ENDIF

   IF !::lStable
       ::End()
       RETU NIL
   ENDIF

   /*
   Creacin de la ventana de impresin
   Creation of the window for printing
   */

   IF !::lScreen

      SysRefresh()   // RWS 2/19/03

      DEFINE DIALOG ::oRptWnd RESOURCE "PRINT_PROC" TITLE ::cName  // "Text Printout" from TRept23

      REDEFINE BUTTON ID IDCANCEL OF ::oRptWnd ;
         ACTION (::lBreak := .T., ::oRptWnd:End()) ;
         WHEN (!::lNoCancel)

      REDEFINE SAY oPagina VAR ::nPage ID 101 OF ::oRptWnd

      SysRefresh()   // RWS 2/19/03

      ::oRptWnd:bPainted := {|| iif(::nPage>0,(SysRefresh(),oPagina:Refresh(),SysRefresh()), )}

      SysRefresh()   // RWS 12/04/07

      ::oRptWnd:bStart := {|| ::Play(),::oRptWnd:End()}

      SysRefresh()   // RWS 12/04/07

      ACTIVATE DIALOG ::oRptWnd CENTER ;
        ON INIT ( SysWait(.1) )   // RWS - to fix lagging paint of dialog.

      SysRefresh()   // RWS 11/13/02 - to fix lagging end of dialog.

   ELSE

      SysRefresh()                   // Added by RWS 11/04/06

      DEFINE DIALOG ::oRptWnd RESOURCE "PREVIEW_PROC" TITLE ::cName

      REDEFINE BUTTON ID IDCANCEL OF ::oRptWnd ;
         ACTION (::lBreak := .T., ::oRptWnd:End()) ;
         WHEN (!::lNoCancel)

      REDEFINE SAY oPagina VAR ::nPage ID 101 OF ::oRptWnd

      ::oRptWnd:bPainted := {|| iif(::nPage>0,oPagina:Refresh(), )}

      SysRefresh()   // RWS 12/04/07

      ::oRptWnd:bStart := {|| ::Play(),::oRptWnd:End()}

      SysRefresh()   // RWS 12/04/07

      ACTIVATE DIALOG ::oRptWnd CENTER

      SysRefresh()                   // Added by RWS 11/04/06

      Eval( ::bPreview, ::oDevice )

      SysRefresh()   // RWS 12/04/07

   ENDIF

RETURN NIL

//----------------------------------------------------------------------------//

METHOD Play() CLASS TReport

   LOCAL nColumns, nGroups, nFor1, nFor2, nFor3, nTotalValue
   LOCAL lSeparator, lFor
   LOCAL nDataHt   // RWS 3/5/02

   SysRefresh()   // RWS 12/04/07

   /*
   Inicializar variables
   Initialize variables
   */

   nColumns   := len(::aColumns)
   nGroups    := len(::aGroups)

   /*
   Comienzo de la Impresin
   Commence printing
   */

   ::StartPage()
   ::Init()

   /*
   Reset de totales por grupo
   Reset the totals of the group
   */

   #ifdef __CLIPPER__
      ASend( ::aGroups, "Reset" )
   #else
      ASend( ::aGroups, "Reset()" )
   #endif

   /*
   Start de grupo
   Start of group
   */

   Aeval(::aGroups,{|val,elem| ::StartGroup(elem) })

   /*
   Bucle de rastreo
   Lock of track
   */

   DO WHILE !::lBreak .AND. eval(::bWhile)

      /*
      Refresh
      */

      SysRefresh()

      /*
      Comprobar condicin for
      Check condition of FOR
      */

      IF !eval(::bFor)
         ::Skip(1)
         LOOP
      ENDIF

      /*
      Condicin de Grupo
      Condition of group
      */

      #ifdef __CLIPPER__
         IF ::lGroup
            ASend( ::aGroups, "Evaluate" )
         ENDIF
      #else
         IF ::lGroup
            ASend( ::aGroups, "Evaluate()" )
         ENDIF
      #endif

      /*
      Cuerpo del Listado
      Body of the report
      */

      // si hay un code-block de evaluacin por cada registro a procesar llamarlo
      // If there is a codeblock for evaluating each record, to process to name it

      IF ::bStartRecord != Nil
         Eval(::bStartRecord, Self)
      ENDIF

      FOR nFor1 := 1 TO ::nMaxData

         ::nDataLine := nFor1

         IF !::lSummary
            lSeparator := (::lSeparator .AND. ;
                           !::lFirstRow .AND. ;
                           nFor1 == 1)
            ::StartLine(::aDataHeight[nFor1], lSeparator)
         ENDIF

         FOR nFor2 := 1 TO nColumns

            CursorWait()  // RWS 2/11/03

            IF !::lSummary
                ::aColumns[nFor2]:SayData(::nRow ,;
                                          ::aCols[nFor2] ,;
                                          nFor1)
            ENDIF

            /*
            Control Sumas
            Control sums
            */

            IF ::lTotal                                    .AND. ;
               ::aColumns[nFor2]:lTotal                    .AND. ;
               (!::aColumns[nFor2]:lTotalExpr .OR.               ;
               eval(::aColumns[nFor2]:bTotalExpr) )

               nTotalValue := eval(::aData[nFor2][nFor1])

               IF valtype(nTotalValue) == "N"

                    ::aColumns[nFor2]:ntotal += nTotalValue

                    IF ::lGroup
                       FOR nFor3 := 1 TO nGroups
                          ::aGroups[nFor3]:aTotal[nFor2] += nTotalValue
                          SysRefresh()   // RWS 12/04/07
                          CursorWait()  // RWS 2/11/03
                       NEXT
                    ENDIF

               ENDIF
            ENDIF
            SysRefresh()   // RWS 12/04/07
            CursorWait()  // RWS 2/11/03
         NEXT

         IF !::lSummary
            ::EndLine(::aDataHeight[nFor1])
            IF ::lDblSpace   // RWS added 3/5/02
               ::EndLine(::aDataHeight[nFor1])
            ENDIF
         ENDIF
         nDataHt := ::aDataHeight[nFor1]

         CursorWait()  // RWS 2/11/03
      NEXT

      /*
      Proximo registro o equivalente
      Near record or equivalent
      */

      ::Skip(1)

      /*
      Control Grupo
      Control group
      */

      IF ::lGroup

         DO WHILE eval(::bWhile) .AND. !eval(::bFor)
            SysRefresh()
            CursorWait()  // RWS 2/11/03
            ::Skip(1)
         ENDDO

         FOR nFor1 := nGroups TO 1 STEP -1
            IF ::aGroups[nFor1]:Check()
               ::EndGroup(nFor1)
               IF ::lDblSpace   // RWS added 3/5/02
                  ::EndLine(nDataHt)
               ENDIF
            ENDIF
            SysRefresh()   // RWS 12/04/07
            CursorWait()  // RWS 2/11/03
         NEXT
         FOR nFor1 := 1 TO nGroups
            IF ::aGroups[nFor1]:lNeedStart
               ::StartGroup(nFor1)
            ENDIF
            SysRefresh()   // RWS 12/04/07
            CursorWait()  // RWS 2/11/03
         NEXT

      ENDIF

      SysRefresh()   // RWS 12/04/07

      CursorWait()  // RWS 2/11/03
   ENDDO

   IF ::lGroup
      FOR nFor1 := nGroups TO 1 STEP -1
         IF !Empty(::aGroups[nFor1]:nCounter)
            ::EndGroup(nFor1)
         ENDIF
         SysRefresh()   // RWS 12/04/07
         CursorWait()  // RWS 2/11/03
      NEXT
   ENDIF

   ::End()
   SysRefresh()
   CursorWait()  // RWS 2/11/03

RETURN NIL

//----------------------------------------------------------------------------//

METHOD Stabilize() CLASS TReport

   LOCAL nColumns, nFor1, nFor2, nMaxHeight, nPrnWidth

   nColumns   := len(::aColumns)
   nMaxHeight := 0

   IF nColumns == 0
      ::lCreated := .F.
      RETU NIL                           // No hay columnas
   ENDIF

   /*
   Calculo del tamao del separador de columnas
   Calculation of the size of the separation of the columns
   */

   IF empty(::nSeparator)
       ::nSeparator := ::oDevice:GetTextWidth(::cCharPattern,::aFont[eval(::bStdFont)])
   ENDIF

   /*
   Clculo del alto standard de una linea
   Calculation of the standard height of one line
   */

   ::nStdLineHeight := ::oDevice:GetTextHeight(::cCharPattern,::aFont[eval(::bStdFont)])

   /*
   Clculo del nmero maximo de titulos y datos pasados a los objetos
   columna
   Calculation of the maximum number of titles and data passed to the column
   objects
   */

   ::nMaxTitle := 0
   ::nMaxData  := 0

   AEval( ::aColumns, {|Val| ::nMaxTitle := Max(len(Val:aTitle),::nMaxTitle) } )
   AEval( ::aColumns, {|Val| ::nMaxData  := Max(len(Val:aData),::nMaxData) } )

   /*
   Generar matriz de trabajo para titulos
   Generate matrix of text for titles
   */

   ::aText := Array(nColumns,::nMaxTitle)

   FOR nFor1 := 1 TO nColumns
      FOR nFor2 := 1 TO ::nMaxTitle
         IF len(::aColumns[nFor1]:aTitle) < nFor2
               ::aText[nFor1][nFor2] := {|| "" }
         ELSE
               ::aText[nFor1][nFor2] := ::aColumns[nFor1]:aTitle[nFor2]
         ENDIF
         SysRefresh()  // RWS 02/11/03
         CursorWait()  // RWS 02/11/03
      NEXT
      SysRefresh()  // RWS 02/11/03
      CursorWait()  // RWS 02/11/03
   NEXT

   /*
   Generar matrices de trabajo para datos de las columnas
   Generate matrices of text for data of the columns
   */

   ::aData    := Array(nColumns,::nMaxData)

   FOR nFor1 := 1 TO nColumns
      FOR nFor2 := 1 TO ::nMaxData
         IF len(::aColumns[nFor1]:aData) < nFor2
               ::aData[nFor1][nFor2] := {|| "" }
         ELSE
               ::aData[nFor1][nFor2] := ::aColumns[nFor1]:aData[nFor2]
         ENDIF
         SysRefresh()  // RWS 02/11/03
         CursorWait()  // RWS 02/11/03
      NEXT
      SysRefresh()  // RWS 02/11/03
      CursorWait()  // RWS 02/11/03
   NEXT

   /*
   Comprobar si hay grupos
   Check if any groups
   */

   ::lGroup := (len(::aGroups)>0)

   /*
   Estabilizar objetos
   Stabilize objects
   */

   ::oHeader:Stabilize()
   ::oFooter:Stabilize()
   ::oTitle:Stabilize()

   Aeval(::aGroups , {|val,elem| val:Stabilize(elem) })
   Aeval(::aColumns, {|val,elem| val:Stabilize(elem) })

   /*
   Comprobar si hay algun total
   Check if there is anything in the total
   */

   ::lTotal := .F.
   aeval(::aColumns,{|Val| iif(Val:lTotal,::lTotal := .T. ,NIL ) })

   /*
   Comprobar si hay alguna columna con Sombra
   Check if there are any columns with a shadow
   */

   ::lShadow := .F.
   aeval(::aColumns,{|Val| iif(Val:lShadow,::lShadow := .T. ,NIL ) })

   /*
   Comprobar si hay alguna columna con Grid
   Check if there are any columns with a grid
   */

   ::lGrid := .F.
   aeval(::aColumns,{|Val| iif(Val:lGrid,::lGrid := .T. ,NIL ) })

   /*
   Clculo del ancho del listado
   Calculation of the width of the report
   */

*cc - at end of aeval...

   ::nRptWidth := 0
   aeval(::aColumns,{|Val| ::nRptWidth += Val:nWidth+::nSeparator })
*cc
*msginfo(LEN(::aColumns),"LEN(::aColumns)")
*msginfo(::nRptWidth,"oRptWidth")
*msginfo(::nSeparator,"nSeparator")

   ::nRptWidth -= ::nSeparator
*cc
*msginfo(::oTitle:nWidth,"oTitle:nWidth")
*msginfo(::oHeader:nWidth,"oHeader:nWidth")
*msginfo(::oFooter:nWidth,"oFooter:nWidth")

   ::nRptWidth := max(::nRptWidth,::oTitle:nWidth)
   ::nRptWidth := max(::nRptWidth,::oHeader:nWidth)
   ::nRptWidth := max(::nRptWidth,::oFooter:nWidth)

   /*
   Si es a un fichero Ascii dimensionar su ancho
   If it is an Ascii file, what is the width
   */

   IF !::lPrinter .AND. !::lScreen
     ::oDevice:nWidth := ::nRptWidth+ (::nSeparator*10)
     ::nWidth         := ::oDevice:nHorzRes()
   ENDIF

   /*
   Si el listado es ms ancho que la pgina advertirlo
   If the report is wider than the page, give a warning
   */
*cc
*msginfo(STR(::nRptWidth)+" "+STR(::nWidth),"nRptWidth nWidth"  )

   IF ::nRptWidth > ::nWidth .AND. (::lScreen .OR. ::lPrinter)
      IF  ::lAutoLand .AND. ;
         !::lIsNarrow .AND. ;
         ::oDevice:GetOrientation() == PORTRAIT

          ::lStable   := .F.
          ::lIsNarrow := .T.
          RETU NIL

      ENDIF
      IF !MsgYesNo(TXT_REPORT_WIDTH, TXT_ATENTION)
          ::lStable := .F.
          RETU NIL
      ENDIF
   ENDIF

   ::nRptWidth := min(::nRptWidth,::nWidth)


   /*
   Margen del Listado
   Margin of the report
   */

   nPrnWidth := ::nWidth - ::nLeftMargin - ::nRightMargin
*   ::nMargin := max(Int((nPrnWidth-::nRptWidth)/2),0) + ::nLeftMargin

   IF !EMPTY(::Cargo)   // RWS 11/02 to force specific left margin size.
      IF ValType(::Cargo) = "N"
         ::nMargin := ::Cargo
        ELSE
         ::nMargin := max(Int((nPrnWidth-::nRptWidth)/2),0) + ::nLeftMargin
      ENDIF
     ELSE
      ::nMargin := max(Int((nPrnWidth-::nRptWidth)/2),0) + ::nLeftMargin
*cc
*msginfo(STR(nPrnWidth)+"  "+STR(::nRptWidth)+"  "+STR(::nWidth)+"  "+STR(::nLeftMargin)+"  "+STR(::nMargin),"nPrnWidth ::nRptWidth ::nWidth ::nLeftMargin ::nMargin - no Cargo")

   ENDIF

   /*
   Calculo de las distintas coordenadas de las columnas del listado
   Calculation of the various coordinates of the report columns
   */

   ::aCols := Array(nColumns)

   ::aCols[1] := iif(::aColumns[1]:nCol>0, ::aColumns[1]:nCol, ::nMargin)
   ::aColumns[1]:nCalCol := ::aCols[1]

   FOR nFor1 := 2 TO nColumns
      IF ::aColumns[nFor1]:nCol>0
         ::aCols[nFor1] := ::aColumns[nFor1]:nCol
      ELSE
         ::aCols[nFor1] := ::aCols[nFor1-1] + ;
                           ::aColumns[nFor1-1]:nWidth + ;
                           ::nSeparator
      ENDIF
      ::aColumns[nFor1]:nCalCol := ::aCols[nFor1]
      SysRefresh()  // RWS 02/11/03
      CursorWait()  // RWS 02/11/03
   NEXT

   /*
   Estabilizar lineas fijas de nuevo indicando coordenadas
   Stabilize newly fixed line margin coordinates
   */

   ::oHeader:Stabilize(::nTopMargin,::nMargin)
   ::oTitle:Stabilize(::oHeader:nHeight+::nTopMargin,::nMargin)
   ::oFooter:Stabilize(::nHeight-::nDnMargin-::oFooter:nHeight,::nMargin)

   /*
   Inicializar variables de coordenadas
   Initialize variables of the coordinates
   */

   Aeval(::aColumns,;
            {|val| nMaxHeight:=Max(nMaxHeight,val:nDataHeight) })

   ::nTitleRow  := ::oHeader:nHeight + ::oTitle:nHeight + ::nTopMargin

   ::nBottomRow := ::nHeight-::oFooter:nHeight-::nDnMargin- ;
                  iif(!::lTotal,0,::nStdLineHeight+nMaxHeight) - ;
                  iif(!::lTotal .AND. ::lSeparator,::oPenHorz:nWidth*10 ,0 ) - ;
                  iif(::lTotal .AND. ::lBoxOnTotal,::nStdLineHeight ,0 )
*cc
*msginfo(str(::nHeight)+"  "+str(::oFooter:nHeight)+"  "+str(::nDnMargin),;
*        "::nHeight  ::oFooter:nHeight  ::nDnMargin")
*msginfo(::nBottomRow,"::nBottomRow")

   /*
   Calcular alto de los titulos
   Calculate height of the titles
   */

   nMaxHeight     := 0
   ::nTitleHeight := 0

   FOR nFor1 := 1 TO ::nMaxTitle

      FOR nFor2 := 1 TO nColumns
         nMaxHeight := Max(nMaxHeight, ::aColumns[nFor2]:nTitleHeight)
         SysRefresh()  // RWS 02/11/03
         CursorWait()  // RWS 02/11/03
      NEXT
      ::nTitleHeight += nMaxHeight

      SysRefresh()  // RWS 02/11/03
      CursorWait()  // RWS 02/11/03
   NEXT

   /*
   Calcular mximo alto de cada linea de datos
   Calculate maximum height of each line of data
   */

   ::aDataHeight := Afill(Array(::nMaxData),0)

   FOR nFor1 := 1 TO ::nMaxData

      Aeval(::aColumns,;
            {|val| ::aDataHeight[nFor1] := Max(::aDataHeight[nFor1],;
                                             val:nDataHeight) })
      SysRefresh()  // RWS 02/11/03
      CursorWait()  // RWS 02/11/03
   NEXT

   /*
   Calcular coordenadas de impresin de datos
   Calculate coordinates for printing of data
   */

   ::nFirstdRow := ::nTitleRow +;
                   iif(!empty(::nTitleUpLine),::nStdLineHeight,0) +;
                   ::nTitleHeight +;
                   iif(!empty(::nTitleDnLine),::nStdLineHeight,0)

   ::nLastdRow  := ::nBottomRow -;
                   iif(::lTotal,::nStdLineHeight/2 ,0 ) - ;
                   iif(!::lTotal .AND. ::lSeparator,::oPenHorz:nWidth*10 ,0 ) -;
                   iif(::lTotal .AND. ::lBoxOnTotal,::nStdLineHeight ,0 )

   /*
   Indicar que ya esta estable
   Indicate if already is stable
   */

   ::lStable := .T.
   ::lFinish := .F.

RETURN (NIL)

//----------------------------------------------------------------------------//

METHOD Init() CLASS TReport

   IF ::bInit != nil
       Eval( ::bInit, Self )
   ENDIF

RETURN NIL

//----------------------------------------------------------------------------//

METHOD End() CLASS TReport

*cc
*msginfo("oReport:End()")

   ::lFinish := .T.

   IF !::lCreated .OR. !::lStable

        IF ::oShdBrush != NIL
            ::oShdBrush:end()
        ENDIF

        #ifndef __XPP__
            ASend( ::aFont, "End" )
            ASend( ::aPen, "End" )
        #else
            ASend( ::aFont, "_End()" )
            ASend( ::aPen, "_End()" )
        #endif

/* Maybe not needed now, due to addition of 7 lines above...
      IF !EMPTY(::aFont)       // RWS 3/31/05 to fix error if print cancelled
        Asend(::aFont,"End")
      ENDIF
      IF !EMPTY(::aPen)
        Asend(::aPen,"End")
      ENDIF
*/

        if ::oPenHorz != nil
           ::oPenHorz:End()
        endif

        ::oDevice:End()
        SetResources(::hOldRes)
        RETU NIL

   ENDIF

   IF !::lBreak .AND. ::bEnd != nil
       Eval( ::bEnd, Self )
   ENDIF
*cc
*msginfo("endpage 3")

*   IF !::lEndPgDone   // ADDED 11/3/06

     ::EndPage()  // If here, then looks for last metafile, already deleted.
                  // So moved down on 7/17/02, but on 8/14/03 this was found
                  // to prevent output of text to last meta page when Adhoc
                  // used. So changed back to original version. Don't remember
                  // situation of the 7/17/02 problem.
*   ENDIF

   SetResources(::hOldRes)

   IF !::lScreen
*cc
*msginfo("endpage 4")

*      ::EndPage()     // RWS moved to here from above 7/17/02
       ::oDevice:End()
   ENDIF


   IF ::oShdBrush != NIL
       ::oShdBrush:end()
   ENDIF

   #ifndef __XPP__
      ASend( ::aFont, "End" )
      ASend( ::aPen, "End" )
   #else
      ASend( ::aFont, "_End()" )
      ASend( ::aPen, "_End()" )
   #endif

   ::oPenHorz:End()

RETURN NIL

//----------------------------------------------------------------------------//

METHOD Skip( n ) CLASS TReport

   STATIC lRunning := .F.

   ::nCounter++

   IF ::bChange != nil .AND. !lRunning
       lRunning := .T.
       Eval( ::bChange, Self )
       lRunning := .F.
   ENDIF

   IF ::bSkip != nil
       retu Eval( ::bSkip, n )
   ENDIF

RETURN DbSkip( n )

//----------------------------------------------------------------------------//

METHOD StartPage() CLASS TReport

   static lRunning := .F.

   ::oDevice:StartPage()

   ::nPage++

   ::oRptWnd:Refresh()

*   ::lEndPgDone := .f.   // Added 11/3/06

   IF ::bStartPage != nil .AND. !lRunning
       lRunning := .T.
       Eval( ::bStartPage, Self )
       lRunning := .F.
   ENDIF

   ::oHeader:Say()
*   ::oTitle:Say()
   ::oTitle:Say(,"T")  // RWS added the "T" parameter to enable TRline:Say() 
   ::ColTitle()        // to give the title a different font from the header.
   ::lFirstRow := .T.  // In this case, title always uses font #3.

RETURN NIL

//----------------------------------------------------------------------------//

METHOD EndPage() CLASS TReport

   STATIC lRunning := .F.
*cc
*msginfo(::nRow,"::nRow in ::EndPage()")

   IF ::bEndPage != nil .AND. !lRunning
       lRunning := .T.
       Eval( ::bEndPage, Self )
       lRunning := .F.
   ENDIF

   ::PageTotal()
   ::oFooter:Say()

   IF ::bPostPage != nil .AND. !lRunning
       lRunning := .T.
       Eval( ::bPostPage, Self )
       lRunning := .F.
   ENDIF

   IF !::lBreak .AND. ::lFinish .AND. ::bPostEnd != nil .AND. !lRunning
       lRunning := .T.
       Eval( ::bPostEnd, Self )
       lRunning := .F.
   ENDIF

   ::oDevice:EndPage()

   IF !(::lFinish)
       ::StartPage()
   ENDIF

RETURN NIL

//----------------------------------------------------------------------------//
*sl
METHOD StartLine(nHeight, lSeparator) CLASS TReport

   STATIC lRunning := .F.

   DEFAULT nHeight    := ::nStdLineHeight ,;
           lSeparator := .F.

   IF nHeight == 0
     RETU NIL
   ENDIF

*cc
*if ::nRow > 3680
*   msginfo(str(nHeight)+" "+str(::nRow)+" "+str(::nBottomRow),"nHeight ::nRow ::nBottomRow")
*endif

   IF (nHeight+::nRow) >= ::nBottomRow
*cc
*msginfo(str(nHeight)+" "+str(::nRow)+" "+str(::nBottomRow),"nHeight ::nRow ::nBottomRow")
*msginfo("EndPage() - Startline()")

*         IF !::lEndPgDone         // Added 11/3/06
            ::EndPage()
            lSeparator := .F.
*            ::lEndPgDone := .t.   // Added 11/3/06
*         ENDIF
   ENDIF

   IF lSeparator
     ::Separator()
   ENDIF

   ::Shadow(nHeight)
   ::Grid(nHeight)

   IF ::bStartLine != nil .AND. !lRunning
      lRunning := .T.
      Eval( ::bStartLine, Self)
      lRunning := .F.
   ENDIF

RETURN nil

//----------------------------------------------------------------------------//
*el
METHOD EndLine(nHeight) CLASS TReport

   STATIC lRunning := .F.

   DEFAULT nHeight := ::nStdLineHeight

   IF ::bEndLine != nil .AND. !lRunning
      lRunning := .T.
      Eval( ::bEndLine, Self)
      lRunning := .F.
   ENDIF

   ::nRow      += nHeight  // Add height of this line to printed length
   ::lFirstRow := .F.

   IF ::NeedNewPage() .AND. !::lEndPgDone 
*cc
*msginfo(STR(::nRow)+" "+STR(::nBottomRow)+" "+STR(::nStdLineHeight),;
*        "::nRow ::nBottomRow ::nStdLineHeight of ::Endline()")
*cc
*msginfo("EndPage() - EndLine()")

       ::EndPage()

   ENDIF
   IF ::nRow < 90
      ::lEndPgDone := .f.
   ENDIF

RETURN nil

//----------------------------------------------------------------------------//

METHOD StartGroup(nGroup) CLASS TReport

   STATIC lRunning := .F.

   ::aGroups[nGroup]:lNeedStart := .F.

   IF !eval(::bWhile) // .OR. !eval(::bFor)
         RETU NIL
   ENDIF

   IF ::bStartGroup != nil .AND. !lRunning
      lRunning := .T.
      Eval( ::bStartGroup, ::aGroups[nGroup])
      lRunning := .F.
   ENDIF

   IF ::aGroups[nGroup]:lHeader
      ::StartLine(::aGroups[nGroup]:nHeaderHeight)
      ::aGroups[nGroup]:Header(::nRow)
      ::EndLine(::aGroups[nGroup]:nHeaderHeight)
   ENDIF

RETURN NIL

//----------------------------------------------------------------------------//

METHOD EndGroup(nGroup) CLASS TReport

   STATIC lRunning := .F.

   IF ::bEndGroup != nil .AND. !lRunning
      lRunning := .T.
      Eval( ::bEndGroup, ::aGroups[nGroup])
      lRunning := .F.
   ENDIF

   IF !::lSummary .AND. ::lTotal
       ::StartLine(::aGroups[nGroup]:nFooterHeight*2)
       ::TotalLine(::nGroupLine, GRID_ABOVE)
   ENDIF

   IF ::aGroups[nGroup]:lFooter
      ::StartLine(::aGroups[nGroup]:nFooterHeight)
      ::aGroups[nGroup]:Footer(::nRow)
      ::EndLine(::aGroups[nGroup]:nFooterHeight)
   ENDIF

   IF ::bPostGroup != nil .AND. !lRunning
      lRunning := .T.
      Eval( ::bPostGroup, ::aGroups[nGroup])
      lRunning := .F.
   ENDIF

   IF !::lFirstRow              .AND. ;
      ::aGroups[nGroup]:lEject  .AND. ;
      eval(::bWhile)            .AND. ;
      eval(::bFor)

      ::EndPage()
   ENDIF

   ::aGroups[nGroup]:Reset()
   ::aGroups[nGroup]:lNeedStart := .T.

RETURN NIL

//----------------------------------------------------------------------------//

METHOD PageTotal() CLASS TReport

   LOCAL nFor, nColumns

   /*
   Si no hay ningun total no hacer nada (salvo separator)
   If there is no total, don't do anything (except for separator)
   */

   IF !(::lTotal) .or. (!::lPageTotal .and. !::lFinish)
      IF ::lSeparator .OR. ::lJoin
          ::TotalLine(::nTotalLine, GRID_ABOVE)
      ENDIF
      RETU (NIL)
   ENDIF

   nColumns := len(::aColumns)

   /*
   Mostrar linea de totales
   To show line of totals
   */

   IF ::lBoxOnTotal
     ::TotalLine(::nTotalLine, GRID_ABOBEL)
     ::Grid()
   ELSE
     ::TotalLine(::nTotalLine, GRID_ABOVE)
   ENDIF

   /*
   Imprimir leyenda de totales (si esta definida, ojo por defecto no esta)
   Print out the totals (if defined, check if don't exist)
   */

   IF ::lFinish
      IF !empty(::cGrandTotal)
         ::oDevice:Say(::nRow                    ,;
                        ::aCols[1]                ,;
                        ::cGrandTotal             ,;
                        ::aFont[eval(::bStdFont)] ,;
                        NIL                       ,;
                        ::aClrText[eval(::bStdFont)],2)
      ENDIF
   ELSE
      IF !empty(::cPageTotal)
         ::oDevice:Say(::nRow                    ,;
                        ::aCols[1]                ,;
                        ::cPageTotal              ,;
                        ::aFont[eval(::bStdFont)] ,;
                        NIL                       ,;
                        ::aClrText[eval(::bStdFont)],2)
      ENDIF
   ENDIF

   /*
   Imprimir los totales para las columnas que lo lleven
   Print totals for the columns
   */

   FOR nFor := 1 TO nColumns
      ::aColumns[nFor]:SayTotal(::nRow, ::aCols[nFor])
      SysRefresh()  // RWS 02/11/03
      CursorWait()  // RWS 02/11/03
   NEXT

   ::nRow += ::nStdLineHeight

   IF ::lBoxOnTotal
      ::TotalLine(::nTotalLine, GRID_ABOVE)
   ENDIF

RETURN NIL

//----------------------------------------------------------------------------//

METHOD ColTitle() CLASS TReport

   LOCAL nFor1, nFor2, nColumns, nMaxHeight, nBegRow, nEndRow

   nColumns   := len(::aColumns)
   nMaxHeight := 0

   ::nRow := ::nTitleRow

   /*
   Imprimir linea superior de titulos
   Print line above the titles
   */

   ::TotalLine(::nTitleUpLine, GRID_BELOW)

   /*
   Descriptores de titulos de cada columna
   Descriptors of titles of each column
   */

   FOR nFor1 := 1 TO ::nMaxTitle

      FOR nFor2 := 1 TO nColumns

         ::aColumns[nFor2]:saytitle(::nRow ,;
                                    ::aCols[nFor2] ,;
                                    nFor1 )
         nMaxHeight := Max(nMaxHeight, ::aColumns[nFor2]:nTitleHeight)
         SysRefresh()  // RWS 02/11/03
         CursorWait()  // RWS 02/11/03
      NEXT

      IF !empty(::nTitleUpLine)
           ::Grid(nMaxHeight)
      ENDIF

      ::nRow += nMaxHeight
      nMaxHeight := 0

      SysRefresh()  // RWS 02/11/03
      CursorWait()  // RWS 02/11/03
   NEXT

   /*
   Imprimir linea inferior de titulos
   Print line below the titles
   */

   ::TotalLine(::nTitleDnLine, GRID_ABOBEL)

   ::lFirstRow := .T.

RETURN NIL

//----------------------------------------------------------------------------//

METHOD TotalLine(nType, nGrid) CLASS TReport

     LOCAL nFor, nColumns, nJoin, nGridRow, nGridHeight, nHeight
     LOCAL cChar, cLeft, cRight

     IF nType == NIL .OR. empty(nType)
          RETU NIL
     ENDIF

     DEFAULT nGrid := GRID_ABOVE

     nJoin       := iif(::lJoin,::nSeparator/2 ,0 )
     nGridRow    := 0
     nGridHeight := 0
     cChar       := ""
     cLeft       := ""
     cRight      := ""

     nColumns := len(::aColumns)

     IF nType == RPT_SINGLELINE

          IF ::lScreen .OR. ::lPrinter

               nHeight := Int(::oPenHorz:nWidth*10)

               DO CASE
               CASE nGrid == GRID_ABOVE
                    nGridRow    := ::nRow
                    nGridHeight := Int(nHeight*.5)
               CASE nGrid == GRID_BELOW
                    nGridRow    := ::nRow+Int(nHeight*.5)
                    nGridHeight := Int(nHeight*.5)
               CASE nGrid == GRID_ABOBEL
                    nGridRow    := ::nRow
                    nGridHeight := nHeight
               ENDCASE

               ::Grid(nGridHeight, nGridRow, cChar)

               FOR nFor := 1 TO nColumns

                    ::oDevice:Line(::nRow+Int(nHeight*.5) ,;
                        ::aCols[nFor] - nJoin ,;
                        ::nRow+Int(nHeight*.5) ,;
                        ::aCols[nFor]+::aColumns[nFor]:nWidth + nJoin ,;
                        ::oPenHorz)

                    SysRefresh()  // RWS 02/11/03
                    CursorWait()  // RWS 02/11/03
               NEXT nFor

          ELSE

               nHeight     := ::nStdLineHeight
               nGridRow    := ::nRow
               nGridHeight := nHeight

               DO CASE
               CASE nGrid == GRID_ABOVE
                    cChar  := ""
                    cLeft  := ""
                    cRight := ""
               CASE nGrid == GRID_BELOW
                    cChar  := ""
                    cLeft  := ""
                    cRight := ""
               CASE nGrid == GRID_ABOBEL
                    cChar  := ""
                    cLeft  := ""
                    cRight := ""
               ENDCASE

               ::Grid(nGridHeight, nGridRow, cChar)

               FOR nFor := 1 TO nColumns

                    ::oDevice:Say(::nRow,;
                        ::aCols[nFor],;
                        Replicate("",::aColumns[nFor]:nWidth) ,;
                        ::aFont[eval(::bStdFont)],;
                        ::aColumns[nFor]:nWidth)

                    IF nFor == 1 .AND. ::aColumns[nFor]:lGrid
                         ::oDevice:Say(::nRow,;
                             ::aCols[nFor]-1,;
                             cLeft ,;
                             ::aFont[eval(::bStdFont)],1)
                    ENDIF

                    IF nFor == nColumns .AND. ::aColumns[nFor]:lGrid
                         ::oDevice:Say(::nRow,;
                             ::aCols[nFor]+::aColumns[nFor]:nWidth,;
                             cRight ,;
                             ::aFont[eval(::bStdFont)],1)
                    ENDIF

                    SysRefresh()  // RWS 02/11/03
                    CursorWait()  // RWS 02/11/03
               NEXT nFor

          ENDIF

     ELSEIF nType == RPT_DOUBLELINE

          IF ::lScreen .OR. ::lPrinter

               nHeight := ::oPenHorz:nWidth*10

               DO CASE
               CASE nGrid == GRID_ABOVE
                    nGridRow    := ::nRow
                    nGridHeight := Int(nHeight*.6)
               CASE nGrid == GRID_BELOW
                    nGridRow    := ::nRow+Int(nHeight*.4)
                    nGridHeight := Int(nHeight*.6)
               CASE nGrid == GRID_ABOBEL
                    nGridRow    := ::nRow
                    nGridHeight := nHeight
               ENDCASE

               ::Grid(nGridHeight, nGridRow, cChar)

               FOR nFor := 1 TO nColumns

                    ::oDevice:Line(::nRow+Int(nHeight*.4) ,;
                        ::aCols[nFor] - nJoin ,;
                        ::nRow+Int(nHeight*.4) ,;
                        ::aCols[nFor]+::aColumns[nFor]:nWidth + nJoin ,;
                        ::oPenHorz)

                    ::oDevice:Line(::nRow+Int(nHeight*.6),;
                        ::aCols[nFor] - nJoin ,;
                        ::nRow+Int(nHeight*.6) ,;
                        ::aCols[nFor]+::aColumns[nFor]:nWidth + nJoin ,;
                        ::oPenHorz)

                    SysRefresh()  // RWS 02/11/03
                    CursorWait()  // RWS 02/11/03
               NEXT nFor

          ELSE

               nHeight     := ::nStdLineHeight
               nGridRow    := ::nRow
               nGridHeight := nHeight

               DO CASE
               CASE nGrid == GRID_ABOVE
                    cChar  := ""
                    cLeft  := ""
                    cRight := ""
               CASE nGrid == GRID_BELOW
                    cChar  := ""
                    cLeft  := ""
                    cRight := ""
               CASE nGrid == GRID_ABOBEL
                    cChar  := ""
                    cLeft  := ""
                    cRight := ""
               ENDCASE

               ::Grid(nGridHeight, nGridRow, cChar)

               FOR nFor := 1 TO nColumns

                    ::oDevice:Say(::nRow,;
                        ::aCols[nFor],;
                        Replicate("",::aColumns[nFor]:nWidth) ,;
                        ::aFont[eval(::bStdFont)],;
                        ::aColumns[nFor]:nWidth)

                    IF nFor == 1 .AND. ::aColumns[nFor]:lGrid
                         ::oDevice:Say(::nRow,;
                             ::aCols[nFor]-1,;
                             cLeft ,;
                             ::aFont[eval(::bStdFont)],1)
                    ENDIF

                    IF nFor == nColumns .AND. ::aColumns[nFor]:lGrid
                         ::oDevice:Say(::nRow,;
                             ::aCols[nFor]+::aColumns[nFor]:nWidth,;
                             cRight ,;
                             ::aFont[eval(::bStdFont)],1)
                    ENDIF

                    SysRefresh()  // RWS 02/11/03
                    CursorWait()  // RWS 02/11/03
               NEXT nFor

          ENDIF

     ENDIF

     ::nRow += nHeight

RETURN NIL
*-----------------------------------
// Prior inline method converted to regular method by RWS on 10/30/06 in order
// to fix problem where ::EndPage() was being called twice for the same page,
// once by TRept23 and again here, resulting in printing of a blank page.
METHOD NeedNewPage() CLASS TReport
LOCAL lRet := .f.

IF ::lRept23
   // Eliminate adding ::StdLineHeight again, which has already been added
   // in ::EndLine(), because adding it 2X erroneously triggers ::EndPage()...
   lRet := ( ::nRow >= ::nBottomRow )
ELSE
   lRet := ( ::nRow+ ::nStdLineHeight >= ::nBottomRow )
ENDIF

RETURN lRet
*-----------------------------------
